package cn.iocoder.byzs.module.bjdx.service.questionnaireresultdetails;

import cn.hutool.core.collection.CollUtil;
import org.springframework.stereotype.Service;
import jakarta.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;
import cn.iocoder.byzs.module.bjdx.controller.admin.questionnaireresultdetails.vo.*;
import cn.iocoder.byzs.module.bjdx.dal.dataobject.questionnaireresultdetails.QuestionnaireResultDetailsDO;
import cn.iocoder.byzs.framework.common.pojo.PageResult;
import cn.iocoder.byzs.framework.common.pojo.PageParam;
import cn.iocoder.byzs.framework.common.util.object.BeanUtils;

import cn.iocoder.byzs.module.bjdx.dal.mysql.questionnaireresultdetails.QuestionnaireResultDetailsMapper;

import static cn.iocoder.byzs.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.byzs.framework.common.util.collection.CollectionUtils.convertList;
import static cn.iocoder.byzs.framework.common.util.collection.CollectionUtils.diffList;
import static cn.iocoder.byzs.module.bjdx.enums.ErrorCodeConstants.*;

/**
 * 北京大学-问卷结果-详情 Service 实现类
 *
 * @author lyb
 */
@Service
@Validated
public class QuestionnaireResultDetailsServiceImpl implements QuestionnaireResultDetailsService {

    @Resource
    private QuestionnaireResultDetailsMapper questionnaireResultDetailsMapper;

    @Override
    public Long createQuestionnaireResultDetails(QuestionnaireResultDetailsSaveReqVO createReqVO) {
        // 插入
        QuestionnaireResultDetailsDO questionnaireResultDetails = BeanUtils.toBean(createReqVO, QuestionnaireResultDetailsDO.class);
        questionnaireResultDetailsMapper.insert(questionnaireResultDetails);
        // 返回
        return questionnaireResultDetails.getId();
    }

    @Override
    public void updateQuestionnaireResultDetails(QuestionnaireResultDetailsSaveReqVO updateReqVO) {
        // 校验存在
        validateQuestionnaireResultDetailsExists(updateReqVO.getId());
        // 更新
        QuestionnaireResultDetailsDO updateObj = BeanUtils.toBean(updateReqVO, QuestionnaireResultDetailsDO.class);
        questionnaireResultDetailsMapper.updateById(updateObj);
    }

    @Override
    public void deleteQuestionnaireResultDetails(Long id) {
        // 校验存在
        validateQuestionnaireResultDetailsExists(id);
        // 删除
        questionnaireResultDetailsMapper.deleteById(id);
    }

    @Override
        public void deleteQuestionnaireResultDetailsListByIds(List<Long> ids) {
        // 校验存在
        validateQuestionnaireResultDetailsExists(ids);
        // 删除
        questionnaireResultDetailsMapper.deleteByIds(ids);
        }

    private void validateQuestionnaireResultDetailsExists(List<Long> ids) {
        List<QuestionnaireResultDetailsDO> list = questionnaireResultDetailsMapper.selectByIds(ids);
        if (CollUtil.isEmpty(list) || list.size() != ids.size()) {
            throw exception(QUESTIONNAIRE_RESULT_DETAILS_NOT_EXISTS);
        }
    }

    private void validateQuestionnaireResultDetailsExists(Long id) {
        if (questionnaireResultDetailsMapper.selectById(id) == null) {
            throw exception(QUESTIONNAIRE_RESULT_DETAILS_NOT_EXISTS);
        }
    }

    @Override
    public QuestionnaireResultDetailsDO getQuestionnaireResultDetails(Long id) {
        return questionnaireResultDetailsMapper.selectById(id);
    }

    @Override
    public PageResult<QuestionnaireResultDetailsDO> getQuestionnaireResultDetailsPage(QuestionnaireResultDetailsPageReqVO pageReqVO) {
        return questionnaireResultDetailsMapper.selectPage(pageReqVO);
    }

}